/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  org.bukkit.Bukkit
 *  org.bukkit.Material
 *  org.bukkit.enchantments.Enchantment
 *  org.bukkit.inventory.ItemStack
 *  org.bukkit.inventory.meta.EnchantmentStorageMeta
 *  org.bukkit.inventory.meta.ItemMeta
 *  org.bukkit.inventory.meta.PotionMeta
 *  org.bukkit.potion.PotionType
 */
package hideandseek.utils;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.List;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.enchantments.Enchantment;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.EnchantmentStorageMeta;
import org.bukkit.inventory.meta.ItemMeta;
import org.bukkit.inventory.meta.PotionMeta;
import org.bukkit.potion.PotionType;

public class ItemStackBuilder {
    public static Method setDamageMethod;
    private final ItemStack item;
    private ItemMeta meta;
    private final List<String> lore;

    public ItemStackBuilder(ItemStack var1) {
        this.item = var1;
        this.meta = var1.getItemMeta();
        this.lore = this.meta != null && this.meta.hasLore() ? this.meta.getLore() : new ArrayList<String>();
    }

    public ItemStackBuilder(Material var1) {
        this(new ItemStack(var1));
    }

    public static void loadMethods() {
        try {
            Method[] var0 = Class.forName("org.bukkit.inventory.meta.Damageable").getMethods();
            int var1 = var0.length;
            int var2 = 0;
            while (var2 < var1) {
                Method var3 = var0[var2];
                if (var3.getName().equals("setDamage")) {
                    setDamageMethod = var3;
                    break;
                }
                ++var2;
            }
        }
        catch (Exception exception) {
            // empty catch block
        }
    }

    public ItemStackBuilder setType(Material var1) {
        this.item.setType(var1);
        return this;
    }

    public ItemStackBuilder setName(String var1) {
        this.meta.setDisplayName(var1);
        return this;
    }

    public ItemStackBuilder addLore(String ... var1) {
        String[] var2 = var1;
        int var3 = var1.length;
        int var4 = 0;
        while (var4 < var3) {
            String var5 = var2[var4];
            this.lore.add(var5);
            ++var4;
        }
        return this;
    }

    public ItemStackBuilder clearLore() {
        this.lore.clear();
        return this;
    }

    public ItemStackBuilder addEnchantment(Enchantment var1, int var2) {
        if (this.item.getType().equals((Object)Material.ENCHANTED_BOOK)) {
            ((EnchantmentStorageMeta)this.meta).addStoredEnchant(var1, var2, true);
        } else {
            this.meta.addEnchant(var1, var2, true);
        }
        return this;
    }

    public ItemStackBuilder setAmount(int var1) {
        this.item.setAmount(var1);
        return this;
    }

    public ItemStackBuilder setDurability(int var1) {
        if (setDamageMethod != null) {
            try {
                setDamageMethod.invoke((Object)this.meta, (short)var1);
            }
            catch (Exception var3) {
                var3.printStackTrace();
            }
        } else {
            this.item.setDurability((short)var1);
        }
        return this;
    }

    public void setPotionEffect(PotionType var1, boolean var2, boolean var3) {
        PotionMeta var4 = (PotionMeta)this.item.getItemMeta();
        try {
            PotionMeta.class.getMethod("setBasePotionData", Class.forName("org.bukkit.potion.PotionData")).invoke((Object)var4, Class.forName("org.bukkit.potion.PotionData").getConstructor(PotionType.class, Boolean.TYPE, Boolean.TYPE).newInstance(var1, var2, var3));
        }
        catch (ClassNotFoundException | IllegalAccessException | IllegalArgumentException | InstantiationException | NoSuchMethodException | SecurityException | InvocationTargetException var6) {
            Bukkit.getConsoleSender().sendMessage("[躲猫猫] 使用的药水效果不适用于此minecraft版本, 可尝试其他药水效果比如: POTION:DURABILITY");
        }
        this.meta = var4;
    }

    public ItemStack build() {
        if (this.meta != null) {
            this.meta.setLore(this.lore);
        }
        this.item.setItemMeta(this.meta);
        return this.item;
    }
}

